require "vertpig/version"

module Vertpig
  autoload :Helpers,       'vertpig/helpers'
  autoload :Market,        'vertpig/market'
  autoload :Client,        'vertpig/client'
  autoload :Configuration, 'vertpig/configuration'
  autoload :Currency,      'vertpig/currency'
  autoload :Deposit,       'vertpig/deposit'
  autoload :Order,         'vertpig/order'
  autoload :Quote,         'vertpig/quote'
  autoload :Summary,       'vertpig/summary'
  autoload :Wallet,        'vertpig/wallet'
  autoload :Withdrawal,    'vertpig/withdrawal'

  def self.client
    @client ||= Client.new(configuration.auth)
  end

  def self.config
    yield configuration
    @client = Client.new(configuration.auth)
  end

  def self.configuration
    Configuration.instance
  end

  def self.root
    File.expand_path('../..', __FILE__)
  end
end
